// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/base"
	model "LAPP_LF_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : WorkLineWorkShiftSpecialTimeDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkLineWorkShiftSpecialTime的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
type WorkLineWorkShiftSpecialTimeDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkLineWorkShiftSpecialTimeDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkLineWorkShiftSpecialTimeDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkLineWorkShiftSpecialTimeDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
func NewWorkLineWorkShiftSpecialTimeDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkLineWorkShiftSpecialTimeDAOImplement {
	return &WorkLineWorkShiftSpecialTimeDAOImplement{session, &meta.WorkLineWorkShiftSpecialTime, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) InsertOne(entity *model.WorkLineWorkShiftSpecialTime) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) DeleteOne(workLineId string, workDay string, pos int, begTime grmi.DateTime) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workLineId, workDay, pos, begTime.ToString()}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) SelectOne(workLineId string, workDay string, pos int, begTime grmi.DateTime) (*model.WorkLineWorkShiftSpecialTime, error) {
	var data model.WorkLineWorkShiftSpecialTime
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workLineId, workDay, pos, begTime.ToString()}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) UpdateOne(entity *model.WorkLineWorkShiftSpecialTime) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) Insert(entities *[]model.WorkLineWorkShiftSpecialTime) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) Delete(entities *[]model.WorkLineWorkShiftSpecialTime) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.Select
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkLineWorkShiftSpecialTime, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkLineWorkShiftSpecialTime, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkLineWorkShiftSpecialTime, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.Update
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) Update(entities *[]model.WorkLineWorkShiftSpecialTime) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkLineWorkShiftSpecialTimeDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkLineWorkShiftSpecialTimeDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkLineWorkShiftSpecialTime, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkLineWorkShiftSpecialTime_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkLineWorkShiftSpecialTime_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
